<app-progress-bar [uploadProgress]="uploadProgress"></app-progress-bar>

<mat-vertical-stepper [linear]="true" #stepper>
  <!-- Step 1: Pipeline Selection -->
  <mat-step [stepControl]="pipelineSelectFormGroup">
    <ng-template matStepLabel>Choose Pipeline</ng-template>
    <app-pipeline-selection
      [(ngModel)]="selectedPipeline"
      [entries]="pipelines"
      label="Choose Pipeline"
      (ngModelChange)="onPipelineChange($event)" 
    >
    </app-pipeline-selection>
    <div>
      <button mat-button matStepperNext
              [disabled]="!pipelineIsSelected"
              (click)="onNextStep(stepper)">
        Next
      </button>
    </div>
  </mat-step>
  <!-- Step 2: Template Selection -->
  <mat-step [stepControl]="templateSelectFormGroup">
    <ng-template matStepLabel>Choose Template</ng-template>
    <app-template-selection
      [(ngModel)]="selectedTemplate"
      [label]="'Select Template'"
      [entries]="templates"
      (selectedTemplateChange)="onTemplateSelected($event)"
    ></app-template-selection>
  </mat-step>
  <app-progress-bar [uploadProgress]="uploadProgress"></app-progress-bar>
  <!-- Step 2: File Upload -->
  <mat-step [stepControl]="fileUploadFormGroup" [completed]="uploadTriggered">
    <ng-template matStepLabel>Upload Files</ng-template>
    <app-file-upload
      [acceptedDataTypes]="selectedPipeline.acceptedDataTypes"
      [acceptedFileRegex]="selectedPipeline.matchingFilesReges"
      (filesSelected)="handleFileSelection($event)"
      (uploadTriggered)="onUpload()"
    >
    </app-file-upload>
  </mat-step>


  <!-- Step 3: LLM Extraction -->
  <mat-step [stepControl]="textExtractionFormGroup">
    <ng-template matStepLabel>Extract Text Data (under development)</ng-template>
    <app-metadata-extraction></app-metadata-extraction>
  </mat-step>

  <!-- Step 4: Metadata Questions Step -->
  <mat-step
    [stepControl]="metadataQuestionFormGroup"
    [completed]="metadataQuestionsCompleted"
  >
    <ng-template matStepLabel>Questionnaire (under development)</ng-template>
    <app-metadata-quest
      (questCompleted)="onMetadataQuestCompleted($event)"
    ></app-metadata-quest>
  </mat-step>

  <!-- Metadata Table Step -->
  <mat-step
    [stepControl]="metadataTableFormGroup"
    [completed]="metadataTableCompleted"
  >
    <ng-template matStepLabel>Metadata Table</ng-template>

    <app-checkboxselection></app-checkboxselection>
    <sdrf-table></sdrf-table>
    <!-- move button to the stepper, because the table needs to be a single component  -->
    <div style="margin-top: 10px;">
      <!-- <button mat-flat-button color="primary" (click)="onSubmitAndGoToDownload()">
        Submit
      </button> -->
    </div>
  </mat-step>

  <!-- Metadata Table Step -->
  <mat-step
    [stepControl]="fileDownloadFormGroup"
    [completed]="submitAndGoToDownloadPressed"
  >
    <ng-template matStepLabel>Download</ng-template>
    <app-metadata-downloadpage></app-metadata-downloadpage>
  </mat-step>
</mat-vertical-stepper>
